#ifndef CommDefsH
#define CommDefsH

// structures for handling UDP Packets
#define TOENCHEADER  0x10203040
#define TOENCTRAILER 0x01020304
#define SET_ENCODER 0x01 // Simple Command to set The Encoder to a Value found in Data

#pragma pack(1)
struct TOENC
{
    unsigned long HEADER;
    unsigned long BOARDID;      // Unique ID number for this board
    unsigned long PACKTYPE;   // 0x01 - Normal Pack   0x100 - Configuration Pack
    uint8_t       CWORD[8]; 
    long          ENC_SET[8]; 
    uint8_t       ENCIP[4];
    uint8_t       NETMASK[4];
    uint8_t       GATEWAY[4];
    uint8_t       HOSTIP[4];
    float         SendTime;
    float         RecvTime; 
    long          PORT;
    uint8_t       EncType[8];  // 0 - Roll Over  1 - Hard Limits
    long          EncMin[8];
    long          EncMax[8];
    unsigned long TRAILER;
};

#define FROMENCHEADER  0xA0B0C0D0
#define FROMENCTRAILER 0x0A0B0C0D

#pragma pack(1)
struct FROMENC
{
    unsigned long HEADER;    
    unsigned long BOARDID;
    unsigned long PACKTYPE;   // 0x02 - Normal Reply  0x200 - Config Data
    long          ENCODERS[8];
    unsigned long STATUS[10];
    unsigned long TRAILER;
    
};

#endif //CommDefsH