#ifndef EncoderDefsH
#define EncoderDefsH

// Encoder Data
unsigned long ENCLOOP = 0;

DigitalIn EncPairA[8] = { ( p11 ), ( p13 ), ( p15 ), ( p17 ), ( p19 ), ( p21 ), ( p23 ), ( p25 ) };
DigitalIn EncPairB[8] = { ( p12 ), ( p14 ), ( p16 ), ( p18 ), ( p20 ), ( p22 ), ( p24 ), ( p26 ) };

char EncRaw[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
long EncVal[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
long EncMin[8] = { -1000000, -1000000, -1000000, -1000000, -1000000, -1000000, -1000000, -1000000 };
long EncMax[8] = {  1000000,  1000000,  1000000,  1000000,  1000000,  1000000,  1000000,  1000000 };
uint8_t EncType[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };

// Possible Pair Combinations and the result of increment to use;
//
// Value  Binary     Response
// 0x00  - 0000   -  NO Action
// 0x01  - 0001   -  Decrement
// 0x02  - 0010   -  Increment
// 0x03  - 0011   -  Unknown
// 0x04  - 0100   -  Increment
// 0x05  - 0101   -  No Action
// 0x06  - 0110   -  Unknown
// 0x07  - 0111   -  Decrement
// 0x08  - 1000   -  Decrement
// 0x09  - 1001   -  Unknown
// 0x0A  - 1010   -  No Action
// 0x0B  - 1011   -  Increment
// 0x0C  - 1100   -  Unknown
// 0x0D  - 1101   -  Increment
// 0x0E  - 1110   -  Decrement
// 0x0F  - 1111   -  No Action

#define ENC_NO_ACTION 0
#define ENC_DECREMENT 1
#define ENC_INCREMENT 2
#define ENC_UNKNOWN   3

#define ENC_ROLLOVER  0x00
#define ENC_HARDSTOP  0x01

int EncInc[16] = { ENC_NO_ACTION, ENC_DECREMENT, ENC_INCREMENT, ENC_UNKNOWN, 
                   ENC_INCREMENT, ENC_NO_ACTION, ENC_UNKNOWN,   ENC_DECREMENT,  
                   ENC_DECREMENT, ENC_UNKNOWN,   ENC_NO_ACTION, ENC_INCREMENT,  
                   ENC_UNKNOWN,   ENC_INCREMENT, ENC_DECREMENT, ENC_NO_ACTION };
                   
int EncResponse[4] = { 0, -1, 1, 0 };
int LastInc = 0;

#endif //EncoderDefsH